<?php
namespace Drupal\pylot_bridge\Services;

use Drupal\Core\Cache\Cache;

class RequestService {
    public static function cachedFileGetContent($url, bool $use_include_path = false, $options = null) {
        $cache = \Drupal::cache();
        $context = null;

        $hashStr = $url . $use_include_path;

        if(!empty($options)) {
            $hashStr .= json_encode($options);
            $context = stream_context_create($options);
        }

        $hash = hash('md5', $url);

        $cached_data = $cache->get('bridge_request_' . $hash);

        if($cached_data) {
            return $cached_data->data;
        } else {
            $raw = file_get_contents($url, $use_include_path, $context);

            if($raw) {
                $requestTime = \Drupal::time()->getRequestTime();
                $lifetime = \Drupal::config('pylot_bridge.bridgeconfig')->get('bridge_cache_lifetime');

                $cache->set('bridge_request_' . $hash, $raw, $requestTime + $lifetime);
            }

            return $raw;
        }
    }
}

